// Client GUI for Load Add-Ons
// ================

// RTB snip

if(isFile("config/server/ADD_ON_LIST.cs"))
   exec("config/server/ADD_ON_LIST.cs");
else
   exec("base/server/defaultAddonList.cs");
   
$AddOn__System_LoadAddOn = 1;
export("$AddOn__*","config/server/ADD_ON_LIST.cs");

// RTB endsnip

if (isObject(LoadAddOn))
	LoadAddOn.delete();

exec("./LoadAddOn.gui");

$LoadAddOn::list = "";

// Get add-ons and populate list
function clientCmdReceiveAddOns(%a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10, %a11, %a12, %a13, %a14, %a15, %a16, %a17)
{
	// Clear if found that the list is repeating
	if (strstr($LoadAddOn::list, %a1) >= 0)
		$LoadAddOn::list = "";
	for (%i = 1; %i <= 17; %i++)
	{
		if (%a[%i] $= "")
			continue;
		$LoadAddOn::list = ($LoadAddOn::list $= "") ? %a[%i] : $LoadAddOn::list SPC %a[%i];
	}
	return 1;
}

// Populate add-on list in the gui
function Client_PopulateAddOnList()
{
	LoadAddOn_List.clear();
	%ctrl = LoadAddOn_List.getID();
	
	for (%i = 0; %i < getWordCount($LoadAddOn::list); %i++)
	{
		%y = %i * 31;
		%add = getWord($LoadAddOn::list, %i);
		
		%color = (%color $= "0 0 0 89") ? "0 0 0 0" : "0 0 0 89";
		%checkbox = "LoadAddOn_Box_" @ %i;
		%row = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "0 " @ %y;
			extent = "370 30";
			minExtent = "8 2";
			visible = "1";
			color = %color;
			
			new GuiCheckboxCtrl(%checkbox)
			{
				profile = "GuiCheckboxProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "7 10";
				extent = "10 10";
				minExtent = "8 2";
				visible = "1";
				text = " ";
				bitmap = "base/client/ui/torqueCheck";
			};
			new GuiMLTextCtrl()
			{
				profile = "GuiMLTextProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "20 7";
				extent = "200 20";
				minExtent = "8 2";
				visible = "1";
				allowColorChars = "1";
				text = %add;
				maxChars = "-1";
			};
			new GuiBitmapButtonCtrl()
			{
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "300 4";
				extent = "50 21";
				minExtent = "8 2";
				visible = "1";
				text = "Load";
				groupNum = "-1";
				bitmap = "base/client/ui/button2";
				buttonType = "PushButton";
				command = "Client_LoadAddOn(" @ %add @ ");";
			};
		};
		%row.setName("LoadAddOn_Name_" @ %add);
		%ctrl.add(%row);
		%ctrl.resize(0, 1, 370, %y + 30);
		// Hax to fix some sort of bug
		%row.schedule(1, "resize", 0, %y, 370, 30);
	}
	return 1;
}

// Load the add-on from the server
function Client_LoadAddOn(%add)
{
	$LoadAddOn::list = removeFromList($LoadAddOn::list, %add);
	Client_PopulateAddOnList();
	commandToServer('LoadAddOn', %add);
	return 1;
}

// Load the selected add-ons
function Client_LoadAddOns()
{
	%list = $LoadAddOn::list;
	%found = "";
	for (%i = 0; %i < getWordCount(%list); %i++)
	{
		%checkbox = "LoadAddOn_Box_" @ %i;
		
		if (%checkbox.getValue())
		{
			%add = getWord(%list, %i);
			$LoadAddOn::list = removeFromList($LoadAddOn::list, %add);
			%found = (%found $= "") ? %add : %found SPC %add;
		}
	}
	
	// Remove those that is loading
	Client_PopulateAddOnList();
	
	// Load the add-ons without transmitting to much
	%words = getWordCount(%found);
	for (%i = 0; %i < %words; %i++)
		schedule(%i * 500, 0, commandToServer, 'LoadAddOn', getWord(%found, %i), (%words - 1 > %i));
}

// Force reload add-on from the server
function Client_ForceLoadAddOn()
{
	%add = LoadAddOn_Text.getValue();
	LoadAddOn_Text.setValue("");
	$LoadAddOn::list = removeFromList($LoadAddOn::list, %add);
	Client_PopulateAddOnList();
	commandToServer('ReLoadAddOn', %add);
	return 1;
}

// Ask for add-ons and show list
function Client_PushAddOnList()
{
	Client_PopulateAddOnList();
	Canvas.pushDialog(LoadAddOn);
}

// Remove from list
function removeFromList(%list, %data)
{
	%list = (getWord(%list, 0) == %data) ? strReplace(%list, %data @ ((getWordCount(%list) == 1) ? "" : " "), "") : strReplace(%list, " " @ %data, "");
	// Clean up
	return trim(strReplace(%list, "  ", " "));
}

// Keymapping
if(!$LoadAddOn_Controls)
{
	$remapDivision[$remapCount] = "Load Add-On";
	$remapName[$remapCount] = "Load Add-On List";
	$remapCmd[$remapCount] = "Client_PushAddOnList";
	$remapCount++;
	$LoadAddOn_Controls = 1;
}

if (isPackage(LoadAddOn_ClientPack))
	deactivatePackage(LoadAddOn_ClientPack);

package LoadAddOn_ClientPack
{
	// Just clear it
	function disconnectedCleanup()
	{
		LoadAddOn_List.clear();
		$LoadAddOn::list = "";
		Parent::disconnectedCleanup();
	}
};
activatePackage(LoadAddOn_ClientPack);